/*
=================
BitCryption.cpp
- A program that performs bit shift operations
=================
*/

#include<iostream>
#include<string>

#define LEFTBIT 7
#define RIGHTBIT 6

using std::cin;
using std::cout;
using std::string;
using std::endl;

/*
=================
bitcrypt function
- takes care of the bit manipulations
=================
*/
void bitcrypt(string &str)
{
	unsigned int c; //single character
	bool bit;

	for(int i=0; i<str.length(); i++) //goes through the string the user entered
	{
		c = str[i];

		bit = (c & (1<<LEFTBIT) ? true : false);
		if(c & (1<<RIGHTBIT) != bit) //are the bits different
		{
			if(bit)
			{
				c = c -(1<<LEFTBIT) + (1<<RIGHTBIT);
			}
			else //else the bits are the same and do not need to be switched
			{
				c = c -(1<<RIGHTBIT) + (1<<LEFTBIT);
			}
			str[i] = c; //writes character by character into the string
		}
	}
}

/*
=================
main function
- main program
=================
*/
int main()
{
	string userText;

	cout << "Enter the text to encrypt: ";
	cin >> userText;
	bitcrypt(userText);
	cout << "The Encrypted text is: " << userText << endl;
}