/*
=================
Functions.cpp
- A program that illustrates the use of functions
=================
*/

#include<iostream>

using namespace std;

/*
=================
FUNCTION PROTOTYPES
=================
*/
void FunctionRef(short &);
void FunctionPtr(short *);
void FunctionVal(short );

/*
=================
FunctionRef function
- takes a reference as parameter
=================
*/
void FunctionRef(short &someVarRef)
{
	cout << endl << "Calling FunctionRef, passing a reference" << endl;
	someVarRef *= 2;
	cout << "reference to myVar*2 = " << someVarRef << endl;
}

/*
=================
FunctionPtr function
- takes a parameter passed as pointer
=================
*/
void FunctionPtr(short *someVarPtr)
{
	cout << endl << "Calling FunctionPtr, passing a pointer" << endl;
	*someVarPtr *= 3;
	cout << "pointer to myVar*3 = " << *someVarPtr << endl;
}

/*
=================
FunctionVal function
- takes a parameter passed by value
=================
*/
void FunctionVal(short someVar)
{
	cout << endl << "Calling FunctionVal, passing a value" << endl;
	someVar *= 4;
	cout << "myVar*4 = " << someVar << endl;
}

/*
=================
main function
- main program
=================
*/
int main()
{
	short myVar = 20;

	FunctionVal(myVar); //passing by value
	cout << "myVar after passing by value = " << myVar << endl;

	FunctionRef(myVar); //passing by reference
	cout << "myVar after passing by reference = " << myVar << endl;

	FunctionPtr(&myVar); //passing by reference using a pointer
	cout << "myVar after passing by reference = " << myVar << endl;

	return 0;
}