/*
=================
main.cpp
Main entry point for the Date application
=================
*/

#include "Date.h"

int main()
{
	Date d;		//create the Date object d
	Date *dPtr = &d; //create the pointer, dPtr to the Date object d
	Date &dRef = d; //create the reference, dRef to the Date object d

	Date *heapDate = new Date();

	cout << "The initial date, printed via the object name, is: ";
	d.printDate(); //calls the values as initialized by the default constructor

	cout << "The initial date, printed via a point, is: ";
	dPtr->printDate(); //calls the values as initialized by the default constructor

	cout << "The initial date, printed via a reference, is: ";
	dRef.printDate(); //calls the values as initialized by the default constructor

	d.setDate(2005, 12, 11);
	cout << "The new date, printed via the object name, is: ";
	d.printDate();

	dPtr->setDate(2005, 12, 11);
	cout << "The new date, printed via the object name, is: ";
	dPtr->printDate();

	heapDate->setDate(2005, 12, 14);
	cout << "The new date, as allocated on the heap, is: ";
	heapDate->printDate();

	dRef.setDate(2005, 12, 11);
	cout << "The new date, printed via a reference, is: ";
	dRef.printDate();

	delete heapDate;

	return 0;
}