/*
===============
Catacomb Commander
CataEngine.cpp
===============
*/

#include"CataEngine.h"


/*
======================
CEngine
-Empty Default Constructor
======================
*/
CEngine::CEngine()
{
}

/*
======================
~CEngine
-Empty Destructor
======================
*/
CEngine::~CEngine()
{
}


/*
======================
Control
-Game Movement
======================
*/

void CEngine::Control(int map[][COLUMNS], int x, int y) //via number keypad
{
	int user_input;
	map[x][y] = 3;
	PrintMaze(map,COLUMNS);
	map[x][y] = 0;
	/* use getch built in function to grap input from command line */
	user_input = getch();

	/* recursively analyse user input */

	switch(user_input)
	{
	    case '6':
    			if(map[x][y+1] == 0)
    				Control(map,x,y+1);	//move right
				else
					if(map[x][y+1] == 1)
						Control(map,x,y); //don't move
		break;

		case '4':  //move left
				if(map[x][y-1] == 0)
					Control(map,x,y-1); //move left
				else
					if(map[x][y-1] == 1)
						Control(map,x,y); //don't move
		break;

		case '2':
				if(map[x+1][y] == 0)
					Control(map,x+1,y); //move down
				else
					if(map[x+1][y] == 1)
						Control(map,x,y); //don't move
		break;

		case '8':
				if(map[x-1][y] == 0)
					Control(map,x-1,y); //move up
				else
					if(map[x-1][y] == 1)
						Control(map,x,y); //don't move
		break;

		case 'x': case 'X': break;
		default :
				Control(map,x,y); //don't move
	}
}

/*
======================
PrintMaze
-Draws the Level Map
======================
*/
void CEngine::PrintMaze(int maze[][COLUMNS], int size)	//map creator
{
	/* clear the screen by printing 25 newlines */
	for(int k = 0; k <= 25; k++)
		cout << endl;

	/* draw the map and player */
	for(int i = 0; i <= size - 1; i++)
	{
		for(int j = 0; j <= size - 1; j++)
		{
			if (maze[i][j] == 3)
				cout << "*";  //draw player
			else
			if(maze[i][j] == 1)
				cout <<"#";	 //draw walls
			else
				cout << " ";  //draw halls
		}
		cout << endl;
	}
}
//EOF